--[[SCRIPT DEF v2.00
last update : 30/11/2014
by Eric JACQUIN
I'm using some parts collected on the web. I can't remember all the coders'names but thank you to 
- Francois Pouvreau (cells voltage stuffs), 
- Dean Church + Isaac Davis (average consumption stuff),
- Jenny Gorton (vario stuff)
- The openTX team : wooooooooooowwww !!!!
(...)

As would say our US friends : please use that script for testing purpose only ;)

+ I wrote this half French, half English, sorry to all people that could not speak both languages :)
--]]

-- ONLY FOR 2~6 LIPO CELLS !!
-- ONLY FOR MODE1 TX. If you need MODE2, please adjust the TRIMS section for your needs.

local battCapacity = 5000 -- put here the theorical capacity of your lipo
local NbCells=3 --cells number of your lipo
local SafeRatioForSafeBattCapacity=.25 --let 25% of margin capacity for your lipo
local gazFloor=20 -- if like me your gaz stick has a dead zone at the bottom, put here the value of the offset here (in %).
local imax=40 -- put here the max current supported by your current sensor (mine is FrSky SP-40A). Above that level, the Max.Amp. indicator will blink.
local sourceBatteryVoltage="cell-sum" --("cell-sum" or "vfas" ?) = voltage sensor source = lipo individual cells sensor (mine is FrSky FLVSS "cell-sum") or  current sensor (mine is FrSky SP-40A "vfas")

--[[NB : this telemetry screen use 2 methods to determine the remaining capacity of the lipo pack : 
* the voltage cell, shown on the right part of the icon battery;
* and the consumption measurement from the current sensor (VFAS / FrSky SP-40A), shown in the right part of the battery icon and used in the times to go calculations.
Note that the voltage cells measurement to measure the remaining capacity is very far from perfect: it depends on lipo's brand, age and load !!
But it is a good indicator if you want to know how far you're from killing your pack (and crash) !
After a lot of reading, it seems that you would not let a cell to go under 2.80v. Other wise : death ;)
So I've decided to put 3.00 in the var cellmin (see below).
--]]

local cellmin=3.00 -- put here the minimum voltage for a cell. Under that level, the cell voltage will blink.

local rssimini=42 -- put here the minimum rssi% level. Under that level, the rssi gauge will show a blinking "!!!".

local codeInterGaz="ls12" --put here the channel of your throttle safe switch (mine is a logical switch)
local chgaz = "thr" --throttle stick code

---///////////////////
local battSafeCapacity = battCapacity-(battCapacity*SafeRatioForSafeBattCapacity)
local Alt, Vspd, MaxAlt, MinAlt 
local function init()
	Alt = getFieldInfo("altitude").id
	Vspd = getFieldInfo("vertical-speed").id
	MaxAlt  = getFieldInfo("altitude-min").id
	MinAlt = getFieldInfo("altitude-max").id

end

--            Taille de l'écran : 212 pixels de largeur ; 64 pixels de hauteur
--             Taille du texte en Pixel  :
--                            Value                largeur x hauteur
--                            SMLSIZE                       3x5
--                            0                                 4x6
--                            MIDSIZE                       5x7
--                            DBLSIZE                       8x10
--                            XXLSIZE                      10x14
-- Hidden text attribute
local BOLD  = 0x40
local CONDENSED = 0x08
local FIXEDWIDTH = 0x10

-- Hidden line or rectangle attribute
local FORCE = 0x02 -- draw ??? line or rectangle
local ERASE = 0x04 -- draw white line or rectangle
local ROUND = 0x08 -- draw round rectangle

-- Hidden grey scale for rectangle or line (0 = black, 15 = white)
local function GREY(xx)
  return (xx % 16) * 0x1000
end
local CurVoltage=0
local totminvoltage=0
local myval=0

local xpos=0
local ypos=0
local width=0
local height=0
local maxvalue=0
local minvalue=0
local value=0
local widthval=0
local percent=0
local cligno=0


local CurThr=0
local CurVolt=0
local CurAmp=0
local CurPwr=0
local CurmaHr=0
local AvgThr=0
local AvgAmp=0
local AvgPwr=0
local AvgmaHr=0
local maHrPerMinute = 0
local TotThr=0
local TotAmp=0
local TotPwr=0
local TotmaHr=0
local MinVolt=0
local MaxAmp=0
local MaxPwr=0
 -- Dynamic telemetry data

local Vfas = 216  
local Curr = 217
local Powr = 219
local maHr = 218
	
local cellSumMin =  245
local cellMinMin = 244
local vfasMin = 246
local currententMax = 247
local powerMax = 248

 -- Switches
local Swa = 92
local Swb = 93
local Swc = 94
local Swd = 95
local Swe = 96
local Swf = 97
local Swg = 98
local Swh = 99


local i
local x, y
local timerNow = 0
local TotSamples = 0

local old_hms = 0

local function getCellPourcentFromVoltageMethod0(NbCellsz,CurVoltagez)
	--DEPRECATED / Non utilisé
	local percentz=0
	percentz = math.floor((CurVoltagez-(NbCellsz * 3.5534)) / (NbCellsz * 0.0059))
	if percentz >=0 then return percentz else return 0 end
end
local function getCellPourcentFromVoltageMethod1(NbCellsz,CurVoltagez)
	local percentt=0
	if NbCells==2 then percentt= math.floor((CurVoltagez-6.6)/0.017) end
	if NbCells==3 then percentt= math.floor((CurVoltagez-9.9)/0.0255) end
	if NbCells==4 then percentt= math.floor((CurVoltagez-13.2)/0.034) end
	if NbCells==5 then percentt= math.floor((CurVoltagez-16.5)/0.0425) end
	if NbCells==6 then percentt= math.floor((CurVoltagez-19.8)/0.051) end
	if percentt >=0 then return percentt else return 0 end
	-- Pourcentage de 3,3v (O%) à 4,15v(100%) par élément
	  -- formule pour lipo 2S   %=(T-6.6)/0,017
	  -- formule pour lipo 3S   %=(T-9.9)/0,0255
	  -- formule pour lipo 4S   %=(T-13.2)/0,034
	  -- formule pour lipo 5S   %=(T-16.5)/0,0425
	  -- formule pour lipo 6S	%=(T-19.8)/0,051

end
local function getCellPourcentFromVoltageMethod2(NbCells,CurVoltage)
  --DEPRECATED / Non utilisé
	if NbCells==3 then
		totminvoltage=10.5
		if (CurVoltage > 0 and CurVoltage<= 10.5) then
			return 0
		elseif (CurVoltage > 10.5 and CurVoltage<= 10.95) then
			return 20
		elseif (CurVoltage > 10.95 and CurVoltage<= 11.10) then
			return 40
		elseif (CurVoltage > 11.1 and CurVoltage<= 11.40) then
			return 60
		elseif (CurVoltage > 11.40 and CurVoltage<= 11.70) then
			return 80
		else 
			return 100
		end
	end

	if NbCells==2 then
		totminvoltage=7
		if (CurVoltage > 0 and CurVoltage<= 7.00) then
			return 0
		elseif (CurVoltage > 7.00 and CurVoltage<= 7.3) then
			return 20
		elseif (CurVoltage > 7.3 and CurVoltage<= 7.4) then
			return 40
		elseif (CurVoltage > 7.4 and CurVoltage<= 7.6) then
			return 60
		elseif (CurVoltage > 7.6 and CurVoltage<= 7.8) then
			return 80
		else 
			return 100
		end
	end
	
	end
local function drawHBareGraph(xpos,ypos,width,height,alertvalue,minvalue,maxvalue,value)
	--cadre du graph
	lcd.drawRectangle(xpos, ypos, width, height)
	-- calcul de longueur que doit prendre la barre
	widthval=value*width/maxvalue
	if value>=0 then
		lcd.drawFilledRectangle(xpos+1, ypos+1, widthval-1, height-2,GREY(5)) --12
		lcd.drawRectangle(xpos+widthval,ypos+1,2,height-2)
	end
	if value<=alertvalue then
		lcd.drawText(xpos+width/2, ypos,"!!",SMLSIZE+1+INVERS)
	end
end
local function drawBattVfromConso(xpos,ypos,maxvalue,value)
  lcd.drawPixmap(xpos, ypos, "/SCRIPTS/BMP/batej.bmp")
  percent=value/maxvalue*100
  
  local heightInsideBatt=39
  local widthInsideBatt=21
  local topMarginBatt=9
  local widthPercentLevel=5
  local widthmAhLevel=widthInsideBatt-widthPercentLevel
  local heightmAhValue
  local heightVPercentCellsValue
  
  --hauteur que doit prendre la barre de mA
  heightmAhValue=value*heightInsideBatt/maxvalue
  
  if value>0 then
		--draw barregraph reste mA
		local ci=0
		for ci=ypos+topMarginBatt+heightInsideBatt,ypos+topMarginBatt+heightInsideBatt-heightmAhValue,-2 do
			lcd.drawFilledRectangle(xpos+3,ci-1, widthmAhLevel, 1,GREY(2))
		end
  else --plus de batt !
		lcd.drawText(xpos+13, ypos+heightInsideBatt-22,"!",MIDSIZE+1+INVERS)
		lcd.drawNumber(xpos+4, ypos+heightInsideBatt-7,value,LEFT+SMLSIZE)
		lcd.drawText(xpos+10, ypos+heightInsideBatt-0," mA",SMLSIZE)
  end
  --draw barregraph %VoltageCellsMin
    if sourceBatteryVoltage=="cell-sum" then --si la source c'est le lipo analyser
		heightVPercentCellsValue=getCellPourcentFromVoltageMethod1(NbCells,getValue("cell-min")*NbCells)*heightInsideBatt/100 --hauteur que doit prendre la barre de %VCells (on prend le V de la cellule la plus faible * nb cells)
    else -- si la source, c'est vfas (voltage current sensor)
		heightVPercentCellsValue=getCellPourcentFromVoltageMethod1(NbCells,CurVoltage)*heightInsideBatt/100 --, on prend le voltage relevé par le current sensor
  end
  if heightVPercentCellsValue>heightInsideBatt then heightVPercentCellsValue=heightInsideBatt end -- si capacité > 100%, on met 100%
  lcd.drawFilledRectangle(xpos+3+widthmAhLevel, ypos+topMarginBatt+heightInsideBatt-heightVPercentCellsValue-0, widthPercentLevel, heightVPercentCellsValue+1,GREY(3))
end
local function drawTXv(xpos,ypos)
  local settings = getGeneralSettings()
  percent = (getValue("tx-voltage")-settings.battMin) * 100 / (settings.battMax-settings.battMin)
  lcd.drawText(xpos, ypos+1, "Tx", SMLSIZE)
  drawHBareGraph(xpos+9,ypos,19,7,5,0,100,percent)
  lcd.drawChannel(xpos+29, ypos, "tx-voltage", LEFT+SMLSIZE)
  
end
local function drawRssi(xpos,ypos)
  lcd.drawPixmap(xpos, ypos, "/SCRIPTS/BMP/rssiej.bmp")
  percent = (getValue(200)-rssimini) * 100 / (100-rssimini)
  drawHBareGraph(xpos+8,ypos,19,7,0,0,100,percent) --19
  lcd.drawChannel(xpos+28, ypos+1, 200, LEFT+SMLSIZE)
  lcd.drawText(lcd.getLastPos(),ypos+1, "%", SMLSIZE)
end
local function drawEllipse(col, row, widthe, heighte)
	--DEPRECATED / Non utilisé
	local xe = widthe / 2                             -- half width
    local ye = heighte / 2                            -- half height
    local center_x = col + xe                        -- horizontal center of the ellipse
    local center_y = row + ye                        -- vertical center of the ellipse
    local sin45 = math.sin(math.pi / 4)             -- Sine of 45°
    local ie, je

-- Plot four cardinal points
    lcd.drawPoint(col, center_y)
    lcd.drawPoint(col + widthe, center_y)
    lcd.drawPoint(center_x, row)
    lcd.drawPoint(center_x, row + heighte)

-- Plot horizontal part of the curve
    for ie = 1, math.floor(xe * sin45), 1 do
        je = math.floor(ye * (1 - (ie / xe) ^ 2) ^ 0.5 + 0.5) -- rounded
        lcd.drawPoint(center_x + ie, center_y + je)
        lcd.drawPoint(center_x + ie, center_y - je)
        lcd.drawPoint(center_x - ie, center_y + je)
        lcd.drawPoint(center_x - ie, center_y - je)
    end

-- Plot vertical part of the curve
    for ie = 1, je - 1, 1 do
        je = math.floor(xe * (1 - (ie / ye) ^ 2) ^ 0.5 + 0.5) -- rounded
        lcd.drawPoint(center_x + je, center_y + ie)
        lcd.drawPoint(center_x + je, center_y - ie)
        lcd.drawPoint(center_x - je, center_y + ie)
        lcd.drawPoint(center_x - je, center_y - ie)
    end
end
local function drawRightEllipse(col, row, heighte)
	--DEPRECATED / Non utilisé
    col=col-heighte/2
	widthe=heighte
    local xe = widthe / 2                             -- half width
    local ye = heighte / 2                            -- half height
    local center_x = col + xe                        -- horizontal center of the ellipse
    local center_y = row + ye                        -- vertical center of the ellipse
    local sin45 = math.sin(math.pi / 2)             -- Sine of 45°
    local ie, je

-- Plot four cardinal points
    --lcd.drawPoint(col, center_y) --gauche
	--lcd.drawLine(col, center_y ,col+3, center_y,SOLID,0)
    --lcd.drawPoint(col + widthe, center_y)--droite
    lcd.drawLine(col+widthe+1 ,center_y,col+widthe-3, center_y,SOLID,0)
	--lcd.drawPoint(center_x, row)--haut
	lcd.drawLine(center_x, row-1 ,center_x, row +3,SOLID,0)
	--lcd.drawPoint(center_x, row + heighte) --bas
	lcd.drawLine(center_x, row + heighte+1,center_x, row + heighte-3,SOLID,0)

-- Plot horizontal part of the curve
    for ie = 1, math.floor(xe * sin45), 1 do
        je = math.floor(ye * (1 - (ie / xe) ^ 2) ^ 0.5 + 0.5) -- rounded
        --bas droite
		lcd.drawPoint(center_x + ie, center_y + je)
        --haut droite
		lcd.drawPoint(center_x + ie, center_y - je)
        --lcd.drawPoint(center_x - ie, center_y + je)
        --lcd.drawPoint(center_x - ie, center_y - je)
    end

-- Plot vertical part of the curve
    --for ie = 1, je - 1, 1 do
    --    je = math.floor(xe * (1 - (ie / ye) ^ 2) ^ 0.5 + 0.5) 
    --    lcd.drawPoint(center_x + je, center_y + ie)
    --    lcd.drawPoint(center_x + je, center_y - ie)
    --    lcd.drawPoint(center_x - je, center_y + ie)
    --    lcd.drawPoint(center_x - je, center_y - ie)
   -- end
	
end
local function drawVarioOLD()
	--DEPRECATED / Non utilisé
--Vertical Speed
-- background
	local x1 = 22--37
	local y1 = 35--32
	local angle
	local x2
	local y2

	--cercle vario
	lcd.drawPixmap(0,11, "/SCRIPTS/BMP/varioej2.bmp")
	--lcd.drawRectangle(75,2,62,62,0)
	

	
	local Vspeed = getValue(Vspd)--get vspeed in m/s
	local indicatedSpeed = 0
	if Vspeed>10 then
		indicatedSpeed=10
	elseif Vspeed<-10 then
		indicatedSpeed=-10
	else
		indicatedSpeed=Vspeed
	end
-- draw indicator
	angle = math.rad((indicatedSpeed*17)-180)
	x2 = 22 * math.cos(angle) + x1 
	y2 = 22 * math.sin(angle) + y1 
	lcd.drawLine(x1, y1, x2, y2, SOLID, 0)--GREY_DEFAULT)
	lcd.drawChannel(x1-1,y1-6, Vspd, MIDSIZE+LEFT)
	
	-- curseurs vario
	local yVarioM=5
	x2=30
	if Vspeed>=5 then --5
		lcd.drawPixmap(x1+x2, yVarioM+15, "/SCRIPTS/BMP/up.bmp")
		lcd.drawPixmap(x1+x2, yVarioM+25, "/SCRIPTS/BMP/up.bmp")
	elseif (Vspeed>0  and Vspeed<5) then --0
		lcd.drawPixmap(x1+x2, yVarioM+15, "/SCRIPTS/BMP/up.bmp")
	elseif Vspeed==0 then --0
		--lcd.drawPixmap(x1+x2, yVarioM+15, "/SCRIPTS/BMP/middle.bmp")
	elseif (Vspeed<0  and Vspeed>-5) then --0
		lcd.drawPixmap(x1+x2, yVarioM+29, "/SCRIPTS/BMP/down.bmp")
	else
		lcd.drawPixmap(x1+x2, yVarioM+29, "/SCRIPTS/BMP/down.bmp")
		lcd.drawPixmap(x1+x2, yVarioM+39, "/SCRIPTS/BMP/down.bmp")
	end
	
	-- altitudes
	
	--altidude max
	lcd.drawText(x1+9, 10, "Max ", SMLSIZE)
	lcd.drawChannel(lcd.getLastPos(),10, "altitude-max", LEFT+SMLSIZE)
	--altidude inst
	lcd.drawChannel(x1+15, 52, "altitude", LEFT+MIDSIZE)
	--ligne V Vario
	lcd.drawFilledRectangle(x1+51,8,2,64-8,GREY(5))
	-- bg curseurs vario
	lcd.drawFilledRectangle(x1+x2-2,yVarioM+13,20,yVarioM+29,GREY(12))
end
local function drawVario(x,y)
--Vertical Speed
-- background
	local x1 = x+1--37
	local y1 = y+24--32
	local angle
	local x2
	local y2

	--cercle vario
	lcd.drawPixmap(x+1,y+6, "/SCRIPTS/BMP/varioejj.bmp")

	local Vspeed =getValue(Vspd)--get vspeed in m/s
	local indicatedSpeed = 0
	if Vspeed>10 then
		indicatedSpeed=10
	elseif Vspeed<-10 then
		indicatedSpeed=-10
	else
		indicatedSpeed=Vspeed
	end
-- draw indicator
	angle = -math.rad((indicatedSpeed*9)-180)
	--lcd.drawText(x1,y1, angle, MIDSIZE)
	x2 = -18 * math.cos(angle) + x1 
	y2 = -18 * math.sin(angle) + y1 
	lcd.drawLine(x1, y1,x2, y2, SOLID, 0)--GREY_DEFAULT)
	lcd.drawFilledRectangle(-22 * math.cos(angle) + x1-2,-22 * math.sin(angle) + y1 -2,4,4,GREY(1)) 
	--lcd.drawText(x1,y1-3,5.2, SMLSIZE)
	lcd.drawChannel(x1,y1-3, Vspd, SMLSIZE+LEFT)
	-- curseurs vario
	local yVarioM=5
	x2=35
	if Vspeed>=5 then --5
		lcd.drawPixmap(x1+x2-5, yVarioM+15, "/SCRIPTS/BMP/up.bmp")
		lcd.drawPixmap(x1+x2-5, yVarioM+25, "/SCRIPTS/BMP/up.bmp")
	elseif (Vspeed>0  and Vspeed<5) then --0
		lcd.drawPixmap(x1+x2-5, yVarioM+15, "/SCRIPTS/BMP/up.bmp")
	elseif Vspeed==0 then --0
	elseif (Vspeed<0  and Vspeed>-5) then --0
		lcd.drawPixmap(x1+x2-5, yVarioM+29, "/SCRIPTS/BMP/down.bmp")
	else
		lcd.drawPixmap(x1+x2-5, yVarioM+29, "/SCRIPTS/BMP/down.bmp")
		lcd.drawPixmap(x1+x2-5, yVarioM+39, "/SCRIPTS/BMP/down.bmp")
	end
	
	-- altitudes
	--altidude max
	lcd.drawText(x2-17, 10, "Max", SMLSIZE)
	lcd.drawChannel(lcd.getLastPos(),10, "altitude-max", LEFT+SMLSIZE)
	--altidude inst
	  lcd.drawChannel(x2-14, y+41, "altitude", LEFT+MIDSIZE)
	--ligne V Vario
	lcd.drawFilledRectangle(x2+20,8,2,64-8,GREY(9))
	-- bg curseurs vario
	lcd.drawFilledRectangle(x1+x2-6,yVarioM+13,17,yVarioM+29,GREY(12))
end
local function background()
  	-- Check and see if the timer2 is zeroed. If it is, let's zero the average.
	-- I use this so that I can re-do the average between flights (where I zero out timer2).
	local timer = 0
	timer = model.getTimer(1)
	if timer.value == 0 then
		timer = model.getTimer(1)
		--  Current values
		CurThr = 0
		CurVolt=0
		CurAmp=0
		CurPwr=0
		CurmaHr=0
		--  Averages values
		AvgThr=0
		AvgAmp=0
		AvgPwr=0
		maHrPerMinute=0
		-- Total values
		TotThr=0
		TotAmp=0
		TotPwr=0
		TotmaHr=0
		--  Summary values
		MinVolt=0
		MaxAmp=0
		MaxPwr=0
		--
		TotSamples=0
	else
		-- ls12(1024) is throttle lock (logical switch)
		-- Don't start averaging until the throttle is moved up and the ls12 is <>1024
		if getValue (chgaz)/10.24 > -100+gazFloor then
			if getValue(codeInterGaz) <1024 then
				CurThr = getValue(chgaz)/10.24
			else
				CurThr = 0
			end
			timer = model.getTimer(1)
			timerNow = timer.value
			TotThr = TotThr+CurThr
			AvgThr = TotThr/TotSamples
			
			CurAmp = getValue(Curr)
			TotAmp = TotAmp+CurAmp
			AvgAmp = TotAmp/TotSamples

			CurPwr = getValue(Powr)
			TotmaHr = getValue(maHr)
			TotPwr = TotPwr+CurPwr	
			AvgPwr = TotPwr/TotSamples		
			TotSamples=TotSamples+1
		end
	end
end
local function hms (hms_x) --convert seconds to h / M /s
	if hms_x == 0 then
		return 0,0,0
	else
		--if (hms_x > 86400 and old_hms>0 and old_hms < 86400) then hms_x=old_hms end
		if hms_x > 86400 then hms_x = 86400 end
		hms_seconds = math.floor(hms_x)
		if hms_seconds < 1 then hms_seconds = 1 end
		
		hms_hours = math.floor(hms_seconds / 3600)
		hms_seconds = math.floor(hms_seconds - (hms_hours * 3600))
		hms_minutes = math.floor(hms_seconds / 60)
		hms_seconds = math.floor(hms_seconds - (hms_minutes * 60))
		if hms_seconds<10 then hms_seconds="0"..hms_seconds end
		if hms_minutes<10 then hms_minutes="0"..hms_minutes end
		old_hms=hms_x
		return hms_hours, hms_minutes, hms_seconds
	end
end


local function run(event)
  

  background()
  lcd.clear()

  CurVoltage=getValue(sourceBatteryVoltage)

--VARIO //////////////////////////////////////
	--drawRightEllipse(1, 17, 36)
	drawVario(0,11)

--TRIMS ////////////////////////////////////////////
	local xtrims=55--x1+52
	local ytrims=12
	local wtrims=18
	local espacetrims=wtrims+7
	local margetrim=2

	--crosses L trim (mode1: RUDD+ELE)
	--Vtrim
	lcd.drawLine(xtrims+margetrim+wtrims/2, ytrims+margetrim,xtrims+margetrim+wtrims/2, ytrims+margetrim+wtrims, SOLID, 0)--GREY_DEFAULT)
	--HTrim
	lcd.drawLine(xtrims+margetrim, ytrims+margetrim+wtrims/2,xtrims+margetrim+wtrims, ytrims+margetrim+wtrims/2, SOLID, 0)--GREY_DEFAULT)
	--crosses R Trims (mode1 : AIL+THR)
	--Vtrim
	lcd.drawLine(xtrims+margetrim+wtrims/2, ytrims+margetrim+espacetrims,xtrims+margetrim+wtrims/2, ytrims+margetrim+wtrims+espacetrims, SOLID, 0)--GREY_DEFAULT)
	--HTrim
	lcd.drawLine(xtrims+margetrim, ytrims+margetrim+wtrims/2+espacetrims,xtrims+margetrim+wtrims, ytrims+margetrim+wtrims/2+espacetrims, SOLID, 0)--GREY_DEFAULT)

	-- drawing trims indicator
	local trim=getValue("trim-rud") --T+L
	local xtrimrud=trim*wtrims/1024/2
	lcd.drawFilledRectangle(xtrimrud+xtrims+margetrim+wtrims/2,ytrims+margetrim+wtrims/2-2,1,5,GREY(2)) 	
	trim=getValue("trim-ail") --T+R
	xtrimrud=trim*wtrims/1024/2
	lcd.drawFilledRectangle(xtrimrud+xtrims+margetrim+wtrims/2,ytrims+margetrim+wtrims/2-2+espacetrims,1,5,GREY(2)) 	
	trim=getValue("trim-thr") --V+R
	xtrimrud=-trim*wtrims/1024/2
	lcd.drawFilledRectangle(xtrims+margetrim+wtrims/2-2,xtrimrud+ytrims+margetrim+wtrims/2+espacetrims,5,1,GREY(2)) 	
	trim=getValue("trim-ele") --V+L
	xtrimrud=-trim*wtrims/1024/2
	lcd.drawFilledRectangle(xtrims+margetrim+wtrims/2-2,xtrimrud+ytrims+margetrim+wtrims/2,5,1,GREY(2)) 	
	 --bg
	lcd.drawFilledRectangle(xtrims,ytrims-4,wtrims+margetrim*3,56,GREY(12))

--TIMERS /////////////////////////////
	local xtimers=78--x1+52
	local ytimers=9

	local timer = model.getTimer(0)
	--Timer Compte à rebours moteur
	lcd.drawPixmap(xtimers+2,ytimers, "/SCRIPTS/BMP/timerej.bmp")
	lcd.drawText(xtimers+14, ytimers+3, "StopWch", SMLSIZE)
	lcd.drawTimer(xtimers+3, ytimers+14, timer.value, DBLSIZE)
	timer = model.getTimer(1)
	--Chrono
	lcd.drawPixmap(xtimers+2,ytimers+37, "/SCRIPTS/BMP/clockej.bmp")
	lcd.drawText(xtimers+18, ytimers+35, "Chrono", SMLSIZE)
	lcd.drawTimer(xtimers+18, ytimers+43, timer.value, MIDSIZE)
    --bg timers
	lcd.drawFilledRectangle(xtimers+1,8,51,56,GREY(14))
	--ligne H Timers
	lcd.drawFilledRectangle(xtimers+1,ytimers+32,51,1,GREY(9))  
	--ligne V1 timers
	lcd.drawFilledRectangle(xtimers-1,ytimers-1,2,64-8,GREY(9))
	--ligne V2 timers
	lcd.drawFilledRectangle(xtimers-2+54,ytimers-1,2,64-8,GREY(9))

--Tx V & RSSI ///////////////////////////////////////
  drawTXv(0,0)
  drawRssi(50,0)
  
--BATTERY ///////////////////////////////////////////
--capacity mainbatt
	drawBattVfromConso(134,12,battSafeCapacity,battSafeCapacity-getValue("consumption"))
	
--%batt
	--%Batt from polynome1 (plus fiable)
	-- myval=getCellPourcentFromVoltageMethod1(NbCells,CurVoltage)
	-- if myval<10 then cligno=1 else cligno=0 end
	lcd.drawText(112,0,NbCells.."c", SMLSIZE+INVERS)
	-- lcd.drawText(lcd.getLastPos()+1,0,myval.."%", SMLSIZE+cligno+INVERS)
	lcd.drawNumber(lcd.getLastPos()+2,1,getValue("consumption"), LEFT+SMLSIZE)
	lcd.drawText(lcd.getLastPos(),1,"mA/", SMLSIZE)
	lcd.drawNumber(lcd.getLastPos(),1,battSafeCapacity, LEFT+SMLSIZE) 

-- ANALYSE V ET AMP /////////////////////////////////////
  
  --ligne H TOPTOPTOPTOP
  lcd.drawFilledRectangle(0, 0, 212, 8,GREY(12)) --12
  --lcd.drawFilledRectangle(0, 8, 212, 1,GREY(1)) --12
  
  --i inst
  local myCurrent=getValue("current")
  --lcd.drawChannel(174,9, "current", MIDSIZE+LEFT)
  lcd.drawText(171,9, myCurrent, MIDSIZE)
  lcd.drawText(lcd.getLastPos(),12, "A", 0)
  lcd.drawFilledRectangle(163,8,49,13,GREY(11))    
  -- time instant
  local consoInstmA=myCurrent*1000
  h,m,s = hms((battSafeCapacity-getValue("consumption"))*3600/ consoInstmA)
  local mystr
  if h==0 then mystr=m..":"..s else mystr=h.."h"..m.."m" end
  lcd.drawText(188,0,mystr,SMLSIZE+INVERS)

  -- [i]
  lcd.drawText(164,23, "i" , SMLSIZE+INVERS)
  if getValue("current-max") >=imax then cligno=INVERS+1 else cligno=0 end
  -- i max
  lcd.drawText(171,23, "Max" , SMLSIZE)
  lcd.drawText(lcd.getLastPos(),23, getValue("current-max"), SMLSIZE+cligno)
  lcd.drawText(lcd.getLastPos(),23, "A", SMLSIZE+cligno)
  -- i avg
  lcd.drawText(171,31, "Avg" , SMLSIZE)
  lcd.drawNumber(lcd.getLastPos()+2,31, AvgAmp, LEFT+SMLSIZE)
  lcd.drawText(lcd.getLastPos(),31, "A", SMLSIZE)
  --avg durée
  lcd.drawText(176,39, "->" , SMLSIZE)
  local  mydurAvg=(battSafeCapacity-getValue("consumption"))*3.6/  AvgAmp
  if AvgAmp>0 then
	h,m,s = hms(mydurAvg)
	if h==0 then mystr=m..":"..s else mystr=h.."h"..m.."m" end
	lcd.drawText(lcd.getLastPos()+2,39,mystr, SMLSIZE)
  else
	
  end
  -- [v]
  if getValue("cell-min") <=cellmin then cligno=INVERS+1 else cligno=0 end
  if  sourceBatteryVoltage=="cell-sum" then
	  lcd.drawText(164,48, "V" , SMLSIZE+INVERS)
	  --v min
	  lcd.drawText(171,49, "Cel" , SMLSIZE)
	  lcd.drawText(lcd.getLastPos()+2,49, getValue("cell-min"), SMLSIZE+cligno)
	  lcd.drawText(lcd.getLastPos(),49, "v", SMLSIZE+cligno)
  else
	  lcd.drawText(164,48, "V" , SMLSIZE+INVERS)
  end  
  -- v tot
  if CurVoltage <=totminvoltage then cligno=INVERS+1 else cligno=0 end
  lcd.drawText(171,57, "Tot" , SMLSIZE)
  lcd.drawChannel(lcd.getLastPos()+2,57, sourceBatteryVoltage, LEFT+SMLSIZE+cligno)
  
  --ligne V Right
  lcd.drawFilledRectangle(162,8,1,64-8,GREY(9))
  --lignes V Electro
  --lcd.drawFilledRectangle(126,8,2,64-8,GREY(5))
  --lcd.drawFilledRectangle(126,0,2,8,GREY(5))
  --ligne H1 Electro
  lcd.drawFilledRectangle(163,21,212-163,1,GREY(9)) 
  --ligne H2 Electro
  lcd.drawFilledRectangle(163,46,212-163,1,GREY(9)) 
  
  
--SECU THROTTLE/GAZ //////////////////////////////////////////////////////////////////
	if getValue("ls12") == 1024 then
		lcd.drawText(0,19,"Secu Gaz ON", SMLSIZE+BLINK+INVERS)
		--lcd.drawFilledRectangle(0, 52,50,13,GREY(1))
  end
end

return { run=run, init=init}